apiVersion: external-secrets.io/v1beta1
kind: SecretStore
metadata:
  name: es-gitlab-secret-store
spec:
  provider:
    vault:
      server: "http://vault.vault:8200"
      path: "kv"
      version: "v2"
      auth:
        kubernetes:
          mountPath: "kubernetes"
          role: "external-secrets-role"
---
apiVersion: external-secrets.io/v1beta1
kind: ExternalSecret
metadata:
  name: es-gitlab-registry
spec:
  refreshInterval: 1m
  secretStoreRef:
    name: es-gitlab-secret-store
    kind: SecretStore
  target:
    name: gitlab-registry-secret
    template:
      type: kubernetes.io/dockerconfigjson
      engineVersion: v2
      data:
        .dockerconfigjson: '{ "auths": { "registry.gitlab.com": { "auth": "{{ printf "%s:%s" .username .password | b64enc }}"}}}'
  data:
  - secretKey: username
    remoteRef:
      key: gitlab/credentials
      property: username
  - secretKey: password
    remoteRef:
      key: gitlab/credentials
      property: password
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: go-sample
spec:
  selector:
    matchLabels:
      app: go-sample
  template:
    metadata:
      labels:
        app: go-sample
    spec:
      containers:
        - image: registry.gitlab.com/yodamad-trash/go-sample/go-sample
          name: go-sample
          ports:
            - containerPort: 80
      imagePullSecrets:
        - name: gitlab-registry-secret

